﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PV178.Lecture2.Wallets
{
    /* Mame dva typy predstavujici penezenku. Jeden u nich je referenci (trida) 
     * a druhy hodnotovy (struct).
     * 
     * Sledujte, co se stane, kdyz se zlodeji pokusi penezenky vykrast.
     */
    class WalletAsReferenceType
    {
        public decimal Money { get; set; }
    }

    struct WalletAsValueType
    {
        public decimal Money { get; set; }
    }

    class Program
    {
        static void Main(string[] args)
        {
            DemoReferenceWallet();

            DemoValueWallet();

            DemoValueWalletPassedAsReference();
        }

        private static void DemoReferenceWallet()
        {
            Console.WriteLine();
            Console.WriteLine("Peněženka jako třída (referenční typ)");

            WalletAsReferenceType referenceWallet = new WalletAsReferenceType();
            referenceWallet.Money = 100;

            Console.WriteLine(referenceWallet.Money);
            Steal1(referenceWallet);
            Console.WriteLine(referenceWallet.Money);
        }

        private static void DemoValueWallet()
        {
            Console.WriteLine();
            Console.WriteLine("Peněženka jako struktura (referenční typ)");

            WalletAsValueType valueWallet = new WalletAsValueType();
            valueWallet.Money = 100;

            Console.WriteLine(valueWallet.Money);
            Steal2(valueWallet);
            Console.WriteLine(valueWallet.Money);
        }

        private static void DemoValueWalletPassedAsReference()
        {
            Console.WriteLine();
            Console.WriteLine("Peněženka jako struktura (hodnotovy typ, ale predani referenci)");

            WalletAsValueType valueWallet = new WalletAsValueType();
            valueWallet.Money = 100;

            Console.WriteLine(valueWallet.Money);
            Steal3(ref valueWallet);
            Console.WriteLine(valueWallet.Money);
        }


        // Metody reprezentujici vykradani penezenky. 
        // Kvuli nazornosti ma kazda vlastni nazev a nejsou pretizene.

        private static void Steal1(WalletAsReferenceType wallet)
        {
            wallet.Money = 0;
        }

        private static void Steal2(WalletAsValueType wallet)
        {
            wallet.Money = 0;
        }

        private static void Steal3(ref WalletAsValueType wallet)
        {
            wallet.Money = 0;
        }
    }
}
